#include "kingate/cgi_interface.h"
#include "kingate/exception.h"

namespace kingate {

    bool cgi_interface::has_meta(const string& n) const {
	return metavars.find(n) != metavars.end();
    }
    const string& cgi_interface::get_meta(const string& n) const {
	metavars_t::const_iterator rv = metavars.find(n);
	if(rv == metavars.end())
	    throw exception_notfound(CODEPOINT,string("no such meta-variable ('")+n+"')");
	return rv->second;
    }

}
